
var networkController = JSB.defineClass('networkController : UIViewController', {
  viewDidLoad: function() {
    self.appInstance = Application.sharedInstance();
    self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
    self.gobackImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goback.png`), 2)
    self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
    self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
    self.snipasteImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/network.png`), 2)
    self.custom = false;
    self.customMode = "None"
    self.dynamic = true;
    self.miniMode = false;
    self.isLoading = false;
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    // self.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    self.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );
    // >>> DeepL langauge button >>>
    // self.webview.lanButton = UIButton.buttonWithType(0);
    // <<< DeepL langauge button <<<
    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    self.view.addSubview(self.webview);
    // <<< DeepL view <<<

// >>> opacity button >>>
    // self.webAppButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<
    // >>> close button >>>
    self.closeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.closeButton,"closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< close button <<<
    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.maxButton,"maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< max button <<<
    // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.screenButton,"changeScreen:")
    self.screenButton.setImageForState(self.screenImage,0)
    // <<< screen button <<<
    // >>> search button >>>
    self.searchButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.searchButton,"searchButtonTapped:")
    self.searchButton.setImageForState(self.snipasteImage,0)

    // self.searchButton.setTitleForState('🔍', 0);
    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.moveButton)
    // <<< move button <<<
    // >>> goForward button >>>
    self.goForwardButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goForwardButton,"goForwardButtonTapped:")
    self.goForwardButton.setImageForState(self.goforwardImage,0)
    // <<< goForward button <<<
      // >>> goBack button >>>
    self.goBackButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goBackButton,"goBackButtonTapped:")
    self.goBackButton.setImageForState(self.gobackImage,0)
    // <<< goBack button <<<

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    // Application.sharedInstance().showHUD("test", self.view.window, 2);

    // self.appInstance.showHUD("123",self.view.window,2)
    // UIView.beginAnimationsContext(undefined,undefined)
    // UIView.setAnimationDuration(10)
    // UIView.commitAnimations
    // UIView.animateWithDurationAnimations(10,1)
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    // self.appInstance.showHUD("123",self.view.window,2)

    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
viewWillLayoutSubviews: function() {
    if (self.miniMode) {
      // self.webview.hidden = true
      return
    }

    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.closeButton.frame = {x: xRight-18,y: yTop,width: 18,height: 18};
    self.maxButton.frame   = {x: xRight-43,y: yTop,width: 18,height: 18};
    self.screenButton.frame = {x: xRight - 37,y: yBottom - 30,width: 30,height: 25};
    self.moveButton.frame = {  x: xRight*0.5-75,  y: yTop,  width: 150,  height: 12,};
    self.searchButton.frame = {  x: xRight - 72,  y: yBottom - 30,  width: 30,  height: 25,}
    self.goBackButton.frame = {  x: xLeft+6,  y: yBottom - 30,  width: 30,  height: 25,};
    self.goForwardButton.frame = {  x: xLeft+41,  y: yBottom - 30,  width: 30,  height: 25,};
    self.webview.frame = {x:xLeft+1,y:yTop+6,width:viewFrame.width-2,height:viewFrame.height-6}
  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
    let currentURL = webView.request.URL().absoluteString()
    //  Application.sharedInstance().showHUD(webView.request.URL().absoluteString(), self.view.window, 2);
    
    if (/^marginnote3app/.test(currentURL)) {
     Application.sharedInstance().showHUD("Return to source...", self.view.window, 2);
    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById(currentURL.match(/(?<=^marginnote3app:\/\/note\/).*/))
      Application.sharedInstance().openURL(NSURL.URLWithString(currentURL));
      webView.stopLoading();
      return
    }
  },
  webViewDidFinishLoad: function(webView) {
    let currentURL = webView.request.URL().absoluteString()
    // self.appInstance.showHUD(currentURL, self.view.window, 2);
    // self.goBackButton.hidden = !webView.canGoBack
    // self.goForwardButton.hidden = !webView.canGoForward
    if (!self.htmlMode) {
      return
    }
    webView.evaluateJavaScript(`
      document.getElementsByClassName("body")[0].offsetHeight
    `,ret=>{
      if (ret !== NSNull.new()) {
        
      // Application.sharedInstance().showHUD(ret, self.view.window, 2);
      let viewFrame = self.view.frame
      viewFrame.height = parseFloat(ret)+40
      self.view.frame = viewFrame
      self.currentFrame = viewFrame
      }
    })
  },
  webViewDidFailLoadWithError: function(webView, error) {
  },

  changeScreen: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();

    menuController.commandTable = [
      {title:'🌗 Left',object:self,selector:'leftButtonTapped:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'left13ButtonTapped:',param:'left',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'rightButtonTapped:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'right13ButtonTapped:',param:'right',checked:self.customMode==="right13"},
      {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender},
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 250,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
  },
  searchButtonTapped: function() {
    let docMapSplitMode = self.appInstance.studyController(self.view.window).docMapSplitMode
      // Application.sharedInstance().showHUD(self.appInstance.studyController(self.view.window).view.subviews, self.view.window, 5)
    // UIPasteboard.generalPasteboard().string = self.appInstance.studyController(self.view.window).view.subviews
    let focusNote
    if (docMapSplitMode===0) {
      focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
    }else{
      focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
    }
    if (focusNote) {
      self.htmlMode = true
      let linkedNotes = focusNote.linkedNotes
      let title = focusNote.noteTitle?focusNote.noteTitle:"..."
      let excerpt = focusNote.excerptText?focusNote.excerptText:""
      let noteColorHexes = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
      let theme = self.appInstance.currentTheme
      let themeHtml = `      
        body{
          -webkit-text-fill-color: rgb(0, 0, 0);
        }`
      if (theme === "Gray") {
        noteColorHexes = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
        themeHtml = `      
        body{
          background-color: #414141;
          -webkit-text-fill-color: rgb(255, 255, 255);
        }`
      }else if (theme === "Dark") {
        noteColorHexes = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
        themeHtml = `      
        body{
          background-color: #121212;
          -webkit-text-fill-color: rgb(233, 232, 232);
        }`
      }
      let nodesHtml = linkedNotes.map((node)=>{
        let nodeNote = Database.sharedInstance().getNoteById(node.noteid)
        let color = noteColorHexes[nodeNote.colorIndex]
        let excerpt = nodeNote.excerptText?nodeNote.excerptText:""
        let label = nodeNote.noteTitle?nodeNote.noteTitle:nodeNote.excerptText
        if (nodeNote.excerptPic) {
          let imageData = Database.sharedInstance().getMediaByHash(nodeNote.excerptPic.paint)
          excerpt = `<img width="100%" src="data:image/jpeg;base64,${imageData.base64Encoding()}"/>`
          label = nodeNote.noteTitle?nodeNote.noteTitle:"image"
        }
        return `{ 
          id: "${node.noteid}", 
          label: "${label}", 
          title:preTitle('<div class="linkedNode" style="border: 3px solid ${color}"><div class="head" style="background-color:${color}"><div class="title">${nodeNote.noteTitle?nodeNote.noteTitle:"..."}</div></div><p class="excerpt">${excerpt}</p><div class="tail"></div></div>'), 
          color:"${color}",
          shape:"box",
          widthConstraint:{maximum:200}
        }`
      })
      .concat(`{ 
        id: "${focusNote.noteid}", 
        label: "${focusNote.noteTitle?focusNote.noteTitle:focusNote.excerptText}", 
        color:"${noteColorHexes[focusNote.colorIndex]}",
        shape:"box",
        borderWidth:"3",
        widthConstraint:{maximum:200}
      }`)
      .join(",")
      let edgesHtml = linkedNotes.map((node)=>{
        return `{ from: "${node.noteid}", to: "${focusNote.noteid}"}`
      })
      .join(",")
      // let comments = focusNote.comments.map(comment=>{
      // // Application.sharedInstance().showHUD(comment.type, self.view.window, 2)
      //   if (comment.type === "TextNote") {
      //     return `<div class="comment">${comment.text}</div>`
      //   }else if (comment.type === "PaintNote") {
      //     let commentImage = Database.sharedInstance().getMediaByHash(comment.paint)
      //     return `<img width="100%" src="data:image/jpeg;base64,${commentImage.base64Encoding()}"/>`
      //   }else{
      //     return ""
      //   }
      // }).join("\n")
      let html = `
<html>
<head>
    <script type="text/javascript" src="https://unpkg.com/vis-network/standalone/umd/vis-network.min.js"></script>

    <style type="text/css">
        #mynetwork {
            width: 100%;
            height: 100%;
            border: 1px solid white;
        }
        .linkedNode {
          width: 100%-5px;
          min-width: 200px;
          max-width: 400px;
          white-space: normal;
          border-radius: 10px 10px 10px 10px;
          font-size: large;
        }
        .head {
          border-radius: 6px 6px 0px 0px;
          line-height: 35px;
        }
        .title {
          padding-left: 10px;
        }
        .excerpt {
          white-space: pre-line;
          padding-left: 10px;
        }
        .tail {
          height: 10px;
        }
    </style>
</head>
<body>
<div id="mynetwork"></div>

<script type="text/javascript">
    // 创建节点数据数组
    var nodes = new vis.DataSet([
      ${nodesHtml}
    ]);

    // 创建边数据数组
    var edges = new vis.DataSet([
      ${edgesHtml}
    ]);

    // 获取容器
    var container = document.getElementById('mynetwork');

    // 将数据赋值给vis 数据格式化器
    var data = {
        nodes: nodes,
        edges: edges
    };
    var options = {};

    // 初始化关系图
    var network = new vis.Network(container, data, options);
    var dateNow = Date.now()
    network.on('click',function(properties){
      console.log(properties)
      if (Date.now()-dateNow < 500 && properties.nodes.length) {
        window.location.assign("marginnote3app://note/"+properties.nodes[0]);//在當前界面打開鏈接
      }
      dateNow = Date.now()
    })
    function preTitle(text) {
      const container = document.createElement("pre");
      container.innerHTML = text;
      return container;
    }
</script>
</body>
</html>

`
            self.webview.loadHTMLStringBaseURL(html)
            self.view.hidden = false
            self.webview.hidden = false

          }else{
            self.appInstance.showHUD("No note selected", self.view.window, 2)
          }
      },
  goBackButtonTapped: function() {
    self.webview.goBack();
  },
  goForwardButtonTapped: function() {
    self.webview.goForward();
  },
  closeButtonTapped: function() {
    self.view.hidden = true;
    },
  leftButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    self.lastFrame = self.view.frame
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.dynamic = false;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "left13"
    self.dynamic = false;
    self.lastFrame = self.view.frame

    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "right"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.custom = true;
    self.customMode = "right13"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.webview.hidden = false
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let translationX = locationInView.x - baseframe.width*0.5
    let translationY = locationInView.y - baseframe.height*0.5
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = Application.sharedInstance().studyController(self.view.window).view.bounds
    let y = frame.y+translationY
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = frame.x+translationX
    if (!self.miniMode) {
      if (x+frame.width*0.5-40<0) {
        self.miniMode = true 
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:0,
          y:frame.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.moveButton.frame = {
          x: -10,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
      if (x>studyFrame.width-frame.width*0.5-40) {
        x=studyFrame.width-frame.width*0.5-40
        self.miniMode = true     
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:studyFrame.width-40,
          y:frame.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true
        self.searchButton.hidden = true
        self.moveButton.frame = {
          x: 0,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
    }else{
      if (x+frame.width*0.5-50<=0) {
        x = -frame.width*0.5+20
      }else if (x>studyFrame.width-frame.width*0.5-50) {
        x = studyFrame.width-40
      }else{
        self.view.frame = {
          x:40,
          y:y,
          width:self.lastFrame.width,
          height:self.lastFrame.height
        }
        self.currentFrame  = self.view.frame
        viewFrame = self.view.bounds;
        self.miniMode = false
        self.moveButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5-75,
          y: viewFrame.y + 5,
          width: 150,
          height: 10,
        };
        self.webview.hidden = false
        self.closeButton.hidden = false
        self.maxButton.hidden = false
        self.screenButton.hidden = false
        self.searchButton.hidden = false
        return
      }
    }
    
    if (self.custom) {
      // Application.sharedInstance().showHUD(self.custom, self.view.window, 2);
      self.customMode = "None"
      self.view.frame = {x:x,y:y,width:self.lastFrame.width,height:self.lastFrame.height}
      self.currentFrame  = self.view.frame

    }else{
      self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
      self.currentFrame  = self.view.frame

    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
});
networkController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }